---
title: RTCIceCandidate.relatedPort
slug: Web/API/RTCIceCandidate/relatedPort
tags:
  - API
  - Address
  - Candidate
  - ICE
  - IP
  - Media
  - Property
  - RTCIceCandidate
  - Reference
  - SDP
  - WebRTC
  - WebRTC API
  - relatedPort
---
<div>{{APIRef("WebRTC")}}</div>

<p><span class="seoSummary">The <strong>{{domxref("RTCIceCandidate")}}</strong> interface's read-only <strong><code>relatedPort</code></strong> property indicates the port number of reflexive or relay candidates.</span> If the candidate is a host candidate (that is, its {{domxref("RTCIceCandidate.ip", "ip")}} is in fact the real IP address of the remote peer), <code>relatedPort</code> is <code>null</code>.</p>

<p>The <code>relatedPort</code> field's value is set when the {{domxref("RTCIceCandidate.RTCIceCandidate", "RTCIceCandidate()")}} constructor is used. You can't specify the value of <code>relatedPort</code> in the options object, but the address is automatically extracted from the {{domxref("RTCIceCandidateInit.candidate", "candidate")}} a-line, if it's formatted properly, being taken from its <code>rel-port</code> field.</p>

<p>The related address ({{domxref("RTCIceCandidate.relatedAddress", "relatedAddress")}}) and port are not used at all by {{Glossary("ICE")}} itself; they are provided for analysis and diagnostic purposes only, and their inclusion may be blocked by security systems, so do not rely on them having non-<code>null</code> values.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>relPort</em> = <em>RTCIceCandidate</em>.relatedPort;</pre>

<h3 id="Value">Value</h3>

<p>An unsigned 16-bit value containing the candidate's related port number, if any. For both peer and server reflexive candidates, the related address and port describe the base for that candidate. For relay candidates, the related address and port provide the mapped address selected by the TURN server.</p>

<p>For host candidates, <code>relatedPort</code> is <code>null</code>, meaning the field is not included in the candidate's a-line.</p>

<h2 id="Usage_notes">Usage notes</h2>

<p>The related address and port are not used by ICE itself, and are only present for diagnostic and Quality-of-Service purposes. They may in fact be omitted for security reasons, but if present can be a useful tool during debugging. See the {{anch("Example", "example")}}, which shows a bit of this.</p>

<p>Here's an {{Glossary("SDP")}} attribute line (a-line) describing an ICE candidate discovered by the STUN server:</p>

<pre>a=candidate:4234997325 1 udp 2043278322 192.168.0.56 6502 typ srflx raddr 192.168.2.77 rport 32768 generation 0</pre>

<p>The remote port, <code>relatedPort</code>, is the number immediately following the <code>"rport"</code> label on the a-line, or 32768.</p>

<h2 id="Example">Example</h2>

<p>In this example, the candidate's {{domxref("RTCIceCandidate.type", "type")}} is checked, and then debugging output is presented, based on the candidate type, including the candidate's type, address (<code>ip</code> and {{domxref("RTCIceCandidate.port", "port")}}), and related address ({{domxref("RTCIceCandidate.relatedAddress", "relatedAddress")}} and <code>relatedPort</code>).</p>

<pre class="brush: js">var ip = candidate.ip;
var port = candidate.port;
var relIP = candidate.relatedAddress;
var relPort = candidate.relatedPort;

if (relIP &amp;&amp; relPort) {
  console.log("Candidate type '" + type + "' -- contact address: " + ip + " " + port + ", related address: " + relIP + " " + relPort);
} else {
  console.log("Host candidate address is " + ip + " " + port);
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebRTC 1.0', '#dom-rtcicecandidate-relatedport', 'RTCIceCandidate.relatedPort')}}</td>
   <td>{{Spec2('WebRTC 1.0')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.RTCIceCandidate.relatedPort")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebRTC_API">WebRTC API</a></li>
 <li><a href="/en-US/docs/Web/API/WebRTC_API/Protocols">Introduction to WebRTC protocols</a></li>
 <li><a href="/en-US/docs/Web/API/WebRTC_API/Connectivity">WebRTC connectivity</a></li>
 <li><a href="/en-US/docs/Web/API/WebRTC_API/Session_lifetime">Lifetime of a WebRTC session</a></li>
 <li>{{domxref("RTCIceCanddiate.relatedAddress")}}</li>
 <li>{{domxref("RTCIceCandidate.ip")}} and {{domxref("RTCIceCandidate.port")}}</li>
</ul>
